﻿#ifndef HCFILEINFO_H
#define HCFILEINFO_H
#include <string>
#include <functional>
namespace  IMSDK{
using PercentCallback = std::function<void(const std::string & msgId, long bytesSend, long bytesTotal)>;
struct HCNETFile{
    bool thumbPIC=false;
    std::string downpath;
    std::string userID;
    std::string token;
    std::string server;
    std::string fileID;
    std::string msgID;
    std::string errorType;
    std::string errorMsg;
    std::string uploadPath;
    std::string encrypteduploadPath;
    std::string roomid;
    std::string fileKey;
    std::string fileUrl;
    int connectTimeout_=10000;
    size_t size;
    std::string uploadName;
    PercentCallback callback=nullptr;

    int progress=0;
    bool encryped =false;
};
class HCFileUtils
{
public:
    HCFileUtils(const std::string &filePath):_origFilePath(filePath) {}
    virtual long long filesize(){return 0;}
    virtual std::string fileSubfix(){ return "";}
    virtual std::string filePrefix(){ return "";}
    virtual std::string split(){return "";}
    //相对路径直接重命名到本目录。
    //绝对路径直接重命名到制定目录.
    //如果已经重命名，成员记录的路径也要修改。
    virtual bool renameto(const std::string & name){return false;}
    virtual bool renameto(const std::string & from ,const std::string & toname){return false;}
    virtual bool remove(const std::string & name){return false;}
    //    virtual bool restore();
    virtual std::string name(){ return "";}
    virtual std::string parentPath(){return "";}
//    virtual bool createDir(){};
    virtual ~HCFileUtils(){}
public:
    std::string _origFilePath;

};

}
#endif // HCFILEINFO_H
